package cn.com.infosec.jce;

import cn.com.infosec.asn1.ASN1InputStream;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.x509.TBSCertList;
import cn.com.infosec.asn1.x509.TBSCertificateStructure;
import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.security.cert.CRLException;
import java.security.cert.CertificateEncodingException;
import java.security.cert.X509CRL;
import java.security.cert.X509Certificate;

public class PrincipalUtil {
   public static X509Principal getIssuerX509Principal(X509Certificate cert) {
      IOException var10000;
      label37: {
         ByteArrayInputStream var9;
         boolean var10001;
         try {
            var9 = new ByteArrayInputStream;
         } catch (IOException var5) {
            var10000 = var5;
            var10001 = false;
            break label37;
         }

         ByteArrayInputStream var1 = var9;

         ASN1InputStream var10;
         try {
            var9.<init>(cert.getTBSCertificate());
            var10 = new ASN1InputStream;
         } catch (IOException var4) {
            var10000 = var4;
            var10001 = false;
            break label37;
         }

         ASN1InputStream cert1 = var10;

         TBSCertificateStructure var11;
         try {
            var10.<init>(var1);
            var11 = new TBSCertificateStructure;
         } catch (IOException var3) {
            var10000 = var3;
            var10001 = false;
            break label37;
         }

         TBSCertificateStructure var8 = var11;

         try {
            var11.<init>((ASN1Sequence)cert1.readObject());
            return new X509Principal(var8.getIssuer());
         } catch (IOException var2) {
            var10000 = var2;
            var10001 = false;
         }
      }

      IOException cert2 = var10000;
      throw new CertificateEncodingException(cert2.toString());
   }

   public static X509Principal getSubjectX509Principal(X509Certificate cert) {
      IOException var10000;
      label37: {
         ByteArrayInputStream var9;
         boolean var10001;
         try {
            var9 = new ByteArrayInputStream;
         } catch (IOException var5) {
            var10000 = var5;
            var10001 = false;
            break label37;
         }

         ByteArrayInputStream var1 = var9;

         ASN1InputStream var10;
         try {
            var9.<init>(cert.getTBSCertificate());
            var10 = new ASN1InputStream;
         } catch (IOException var4) {
            var10000 = var4;
            var10001 = false;
            break label37;
         }

         ASN1InputStream cert1 = var10;

         TBSCertificateStructure var11;
         try {
            var10.<init>(var1);
            var11 = new TBSCertificateStructure;
         } catch (IOException var3) {
            var10000 = var3;
            var10001 = false;
            break label37;
         }

         TBSCertificateStructure var8 = var11;

         try {
            var11.<init>((ASN1Sequence)cert1.readObject());
            return new X509Principal(var8.getSubject());
         } catch (IOException var2) {
            var10000 = var2;
            var10001 = false;
         }
      }

      IOException cert2 = var10000;
      throw new CertificateEncodingException(cert2.toString());
   }

   public static X509Principal getIssuerX509Principal(X509CRL crl) {
      IOException var10000;
      label37: {
         ByteArrayInputStream var9;
         boolean var10001;
         try {
            var9 = new ByteArrayInputStream;
         } catch (IOException var5) {
            var10000 = var5;
            var10001 = false;
            break label37;
         }

         ByteArrayInputStream var1 = var9;

         ASN1InputStream var10;
         try {
            var9.<init>(crl.getTBSCertList());
            var10 = new ASN1InputStream;
         } catch (IOException var4) {
            var10000 = var4;
            var10001 = false;
            break label37;
         }

         ASN1InputStream crl1 = var10;

         TBSCertList var11;
         try {
            var10.<init>(var1);
            var11 = new TBSCertList;
         } catch (IOException var3) {
            var10000 = var3;
            var10001 = false;
            break label37;
         }

         TBSCertList var8 = var11;

         try {
            var11.<init>((ASN1Sequence)crl1.readObject());
            return new X509Principal(var8.getIssuer());
         } catch (IOException var2) {
            var10000 = var2;
            var10001 = false;
         }
      }

      IOException crl2 = var10000;
      throw new CRLException(crl2.toString());
   }
}
